#pragma once

#include <string>
#include <GL\glew.h>
#include <GLFW\glfw3.h>


namespace cgue{

		class Shader {
		public:
			Shader(const std::string& vertexShader, 
				const std::string& fragmentShader);
			Shader(const std::string& vertexShader, 
				const std::string& fragmentShader,const std::string& geometryShader);
			~Shader();
			void useShader() const;
			GLuint programHandle;

		private:
			void loadShader(const std::string& shader, GLenum shaderType, GLuint& handle);
			void link();
			void linkGeometry();

			GLuint vertexHandle;
			GLuint fragmentHandle;
			GLuint geometryHandle;
		};
	};

