#version 330

uniform mat4 cameraMatrix;
uniform mat4 modelMatrix;
uniform mat4 shadowprojectionMatrix[5];
uniform mat4 boneMatrices[26];

in vec3 position;
in vec2 uv;
in vec3 normal;

in ivec4 boneId;
in vec4 boneWeight;

out vec3 fragVert;
out vec3 fragNormal;
out vec2 fragUV;
out vec4 smCoord[5];

void main()
{
	fragUV = vec2(uv);
	fragNormal = normal;
	

	mat4 boneCalculation = mat4(1.0);
	boneCalculation = boneMatrices[boneId.x] * boneWeight.x + boneMatrices[boneId.y] * boneWeight.y + boneMatrices[boneId.z] * boneWeight.z + boneMatrices[boneId.w] * boneWeight.w;		// so you can see a result,
	//boneCalculation = boneMatrices[18] * boneWeight.x + boneMatrices[18] * boneWeight.y + boneMatrices[18] * boneWeight.z + boneMatrices[18] * boneWeight.w;		// so you can see a result,
	vec4 vert1=boneCalculation*vec4(position,1);
	fragVert = vert1.xyz;
	smCoord[0]=shadowprojectionMatrix[0]*modelMatrix*boneCalculation*vec4(position,1);
	smCoord[1]=shadowprojectionMatrix[1]*modelMatrix*boneCalculation*vec4(position,1);
	smCoord[2]=shadowprojectionMatrix[2]*modelMatrix*boneCalculation*vec4(position,1);
	smCoord[3]=shadowprojectionMatrix[3]*modelMatrix*boneCalculation*vec4(position,1);
	smCoord[4]=shadowprojectionMatrix[4]*modelMatrix*boneCalculation*vec4(position,1);

	gl_Position = cameraMatrix * modelMatrix * boneCalculation  * vec4(position,1);
	//gl_Position = cameraMatrix * modelMatrix * vec4(position,1);
}
