#version 420



uniform int anz;
uniform mat4 modelMatrix;
uniform vec3 cameraPosition;

//material
uniform sampler2D colorTexture;
uniform float materialShininess;
uniform vec3 materialSpecularColor;
uniform float transparency;

//Schatten

// uniform sampler2DShadow shadowTexture;
//uncomment
layout(binding=1) uniform sampler2DShadow shadowTexture[5];




uniform struct Light{
	vec3 position;
	vec3 intensities; //light color
	float attenuation;
	float ambientCoefficient;
} light;
uniform struct Spotlight{
	vec3 position;
	vec3 direction;
	float angle;
	vec3 intensities; //light color
} spotlight [5];

in vec2 fragUV;
in vec3 fragNormal;
in vec3 fragVert;
in vec4 smCoord[5];


in vec4 smCoordCalculated1;
in vec4 smCoordCalculated2;

out vec4 fragColor;

void main()
{	
//PCF, funktioniert nicht berall
//vec3 sm_ndc=(smCoord.xyz)/smCoord.w;

//float shadowmult=texture(shadowTexture,sm_ndc).r;








	//calculate normal in world coordinates
    mat3 normalMatrix = transpose(inverse(mat3(modelMatrix)));
    vec3 normal = normalize(normalMatrix * fragNormal);

	//calculate the location of this fragment (pixel) in world coordinates
    //surfacePos
	vec3 surfacePos = vec3(modelMatrix * vec4(fragVert, 1));
	
	vec4 surfaceColor =  texture(colorTexture, fragUV);
	
	//calculate the vector from this pixels surface to the light source
    vec3 surfaceToLight = normalize(light.position - surfacePos);
	vec3 surfaceToCamera = normalize(cameraPosition - surfacePos);
	

	//ambient
	vec3 ambient = light.ambientCoefficient * surfaceColor.rgb * light.intensities;
	
	//diffuse
    //float diffuseCoefficient = dot(normal, surfaceToLight) / (length(surfaceToLight) * length(normal));
    //oberes wird nicht mehr verwendet
	float diffuseCoefficient = dot(normal, surfaceToLight);
	diffuseCoefficient = max(0.0, diffuseCoefficient);
	vec3 diffuse = diffuseCoefficient * surfaceColor.rgb * light.intensities;




	//specular
	float specularCoefficient = 0.0;
	if(diffuseCoefficient > 0.0) {
        specularCoefficient = pow(max(0.0, dot(surfaceToCamera, reflect(-surfaceToLight, normal))), materialShininess);
	}
    vec3 specular = specularCoefficient * materialSpecularColor * light.intensities;


	
	//attenuation
	float distanceToLight = length(light.position - surfacePos);
    float attenuation = 1.0 / (1.0 + light.attenuation * pow(distanceToLight, 2));

	//color before gammacorrection
	vec3 linearColor = ambient + attenuation*(diffuse + specular);


	//Spotlight
	for (int i=0;i<5&&i<anz;i=i+1){
	float shadowmult=1.0;
	float depth_1=0.0;
	vec2 sm_uvs=vec2(0.0,0.0);
	
	sm_uvs=(smCoord[i].xy)/smCoord[i].w;
	 depth_1=(smCoord[i].z)/smCoord[i].w;


	//float depth_2=texture(shadowTexture[i],sm_uvs).r;
	 //shadowmult=(depth_2<depth_1)?0.0:1.0;

	 //uncomment
	 shadowmult=textureProj(shadowTexture[i],smCoord[i]);

	vec3 surfaceToSpotLight = normalize(spotlight[i].position - surfacePos);


		float diffuseSpotlightfactor=dot(surfaceToSpotLight,-spotlight[i].direction)/(length(surfaceToSpotLight) * length(spotlight[i].direction));
		float diffuseSpotlightCoefficient = dot(normal, surfaceToSpotLight)*(1.0-(1.0-diffuseSpotlightfactor)*(1.0/(1.0-spotlight[i].angle)));
		diffuseSpotlightCoefficient = max(0.0, diffuseSpotlightCoefficient);
		vec3 diffusespotlight = diffuseSpotlightCoefficient * surfaceColor.rgb * spotlight[i].intensities;

	float specularSpotlightCoefficient = 0.0;
	if(diffuseSpotlightCoefficient > 0.0) {
        specularSpotlightCoefficient = pow(max(0.0, dot(surfaceToCamera, reflect(-surfaceToSpotLight, normal))), materialShininess);
	}
    vec3 specularSpotlight = specularSpotlightCoefficient * materialSpecularColor * spotlight[i].intensities*(1.0-(1.0-diffuseSpotlightfactor)*(1.0/(1.0-spotlight[i].angle)));



	float distanceToSpotLight = length(spotlight[i].position - surfacePos);
	float spotlightattenuation=1.0 / (1.0 + light.attenuation * pow(distanceToSpotLight, 2));


	if((dot(surfaceToSpotLight,-spotlight[i].direction)/(length(surfaceToSpotLight) * length(spotlight[i].direction)))>spotlight[i].angle){
	linearColor=linearColor+spotlightattenuation*(diffusespotlight+specularSpotlight)*shadowmult;}
	}

	//fragColor(after gammacorrection)
	vec3 gamma = vec3(1.0/2.2);
	fragColor = vec4(pow(linearColor, gamma), surfaceColor.a*transparency);


	//vec4 lightintensities = vec4(light.intensities, 1);

	//fragColor = (diffuseCoefficient) * lightintensities * surfaceColor;
	


	//vec3 color = texture(colorTexture, fragUV).rgb;	
	//fragColor = vec4(color, 1.0);

}