#version 330

uniform mat4 modelMatrix;
uniform sampler2D colorTexture;
//uniform vec3 lightPosition;
//uniform vec3 lightIntensities;

uniform struct Light{
	vec3 position;
	vec3 intensities; //light color
} light;

in vec2 fragUV;
in vec3 fragNormal;
in vec3 fragVert;

//added for directional light.
in vec4 eye;

out vec4 fragColor;

void main()
{
	//calculate normal in world coordinates
    mat3 normalMatrix = transpose(inverse(mat3(modelMatrix)));
    vec3 normal = normalize(normalMatrix * fragNormal);

	//added for directional light. keine ahnung
	vec3 e = normalize(vec3(eye));

	//calculate the location of this fragment (pixel) in world coordinates
    vec3 fragPosition = vec3(modelMatrix * vec4(fragVert, 1));

	//calculate the vector from this pixels surface to the light source
    vec3 surfaceToLight = light.position - fragPosition;

	//calculate the cosine of the angle of incidence (brightness)
    float brightness = dot(normal, surfaceToLight) / (length(surfaceToLight) * length(normal));
    brightness = clamp(brightness, 0, 1);
	
	vec4 lightIntensities2 = vec4(1, 1, 1, 1);

	fragColor = (brightness) * lightIntensities2 * texture(colorTexture, fragUV);

	//fragColor = texture(colorTexture, fragUV);
	//vec3 color = texture(colorTexture, fragUV).rgb;
	//fragColor = (brightness * 10) * vec4(lightIntensities, 1) * vec4(color, 1);
	
	//try black and white shader - works
	//vec4 normalColor = texture2D(colorTexture, fragUV);
	//float gray = 0.299*normalColor.r + 0.587*normalColor.g + 0.114*normalColor.b;
	//fragColor = vec4(gray, gray, gray, 1.0);


	
	//vec3 color = texture(colorTexture, fragUV).rgb;	
	//fragColor = vec4(color, 1.0);
}