#version 330

uniform mat4 cameraMatrix;
uniform mat4 modelMatrix;

in vec3 position;
in vec2 uv;
in vec3 normal;

out vec3 fragVert;
out vec3 fragNormal;
out vec2 fragUV;

//out
out vec4 eye;


void main()
{
	fragUV = vec2(uv);
	fragNormal = normal;
	fragVert = position;  

	eye = -(modelMatrix * vec4(position,1);

	gl_Position = cameraMatrix * modelMatrix * vec4(position,1);
}

